-- Blur.EX
-- Simulate motion-blur using alpha blending.
-- Written in Euphoria
-- This program uses the SDL_Wrap 
-- Mark K. Akita   2/20/03

include file.e
include machine.e
include Sdl_Wrap.e
include misc.e

atom format,pixels
atom dummy
atom keystate
atom surface,buffer,back
atom geetar
atom srect,drect
atom mx,my
integer gmouse

--------------------------------------------------------------------

function abs(atom i)
	if i<0 then
        return -i
    else
        return i 
    end if
end function

--------------------------------------------------------------------

procedure init()
    
    dummy = SDL_Init(SDL_INIT_VIDEO+SDL_INIT_TIMER)
    if dummy = -1 then
        puts(1, "SDL_Init had a hissy fit!\n")
    end if

    surface = SDL_SetVideoMode(640,480,16,SDL_FULLSCREEN)

    format=peek4u(surface+4)
    pixels=peek4u(surface+20)

    srect=allocate(8)

    drect=allocate(8)

    mx=allocate(4)
    my=allocate(4)

    back = SDL_ConvertSurface(surface,format,SDL_HWSURFACE)
    buffer = SDL_ConvertSurface(surface,format,SDL_HWSURFACE)
    geetar=SDL_LoadBMP("Bitmaps/geetar.bmp")
	dummy=SDL_SetColorKey(geetar,SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
    if dummy = -1 then
        puts(1, "SDL_SetColorKey had a hissy fit!\n")
    end if

	dummy=SDL_SetAlpha(back,SDL_SRCALPHA,31)
	if dummy = -1 then
	   	puts(1, "SDL_SetAlpha had a hissy fit!\n")
	end if
       				
end procedure

--------------------------------------------------------------------

procedure calc_rect(atom rect, integer sx, integer sy, integer tx, integer ty)

    poke(rect,and_bits(sx,255))      
    poke(rect+1,floor(sx/256))      
    poke(rect+2,and_bits(sy,255))      
    poke(rect+3,floor(sy/256))      
    poke(rect+4,and_bits(tx,255))      
    poke(rect+5,floor(tx/256))      
    poke(rect+6,and_bits(ty,255))      
    poke(rect+7,floor(ty/256))      

end procedure

--------------------------------------------------------------------

procedure cleanup()
   
-- We're done with them.. Free the surfaces
    SDL_FreeSurface(surface)
    SDL_FreeSurface(buffer)
    SDL_FreeSurface(back)
    SDL_FreeSurface(geetar)

    free(srect)
    free(drect)
    free(mx)
    free(my)

-- quit SDL
    SDL_Quit()   
        
end procedure

--------------------------------------------------------------------

procedure main()

	atom done
	integer mx2,my2
	integer ticks1,ticks2,ticks

	dummy=SDL_FillRect(back,NULL,0)
	done=0    
	while done=0 do

		ticks1=SDL_GetTicks()
    	SDL_PumpEvents()
    	keystate=SDL_GetKeyState(NULL)
    	if peek(keystate+SDLK_ESCAPE)>0 then
				done=1        
		end if
		gmouse=SDL_GetMouseState(mx,my)
		if gmouse = -1 then
			puts(1, "SDL_GetMouseState had a hissy fit!\n")
		end if
		mx2=peek(mx)+256*peek(mx+1)
		my2=peek(my)+256*peek(my+1)
		if gmouse=1 then
				done=1        
		end if

		dummy=SDL_BlitSurface(back,NULL,buffer,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if

		calc_rect(srect,0,0,320,200)
    	calc_rect(drect,mx2-160,my2-100,320,200)
		dummy=SDL_BlitSurface(geetar,srect,buffer,drect)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if

		dummy=SDL_BlitSurface(buffer,NULL,surface,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if
		SDL_UpdateRect(surface,0,0,0,0)

		ticks=0
		while ticks<50 do
			ticks2=SDL_GetTicks()
			ticks=ticks2-ticks1
		end while

	end while

end procedure

--------------------------------------------------------------------

init()
main()
cleanup()


