-- Bounder_SDL.EX
-- The SDL version of the Bounder graphics demo
-- "Everything old is new again"  
-- Mark K. Akita       3/3/03

without type_check

include file.e
include machine.e
include Sdl_Wrap.e
include misc.e

integer c,nt,tl,cc,bb
atom a,ai,d,am,ad,x,y
atom format,pixels
atom dummy
atom keystate
atom surface,buffer,back,back2,back3
atom srect,drect
atom mx,my
atom backs,balls
integer gmouse

-- nt=number of trails 2-5
-- tl=trail length 8-12
-- c=current color 0-11
-- a=current angle 0-pi*2
-- ai=angle increment 0.00-0.20
-- am=angle multiplier 1.0-4.0
-- d=current distance 0-215
-- ad=angle distance
-- co=color offset
-- bb=bounds object

--------------------------------------------------------------------

procedure calc_rect(atom rect, integer sx, integer sy, integer tx, integer ty)

    poke(rect,and_bits(sx,255))      
    poke(rect+1,floor(sx/256))      
    poke(rect+2,and_bits(sy,255))      
    poke(rect+3,floor(sy/256))      
    poke(rect+4,and_bits(tx,255))      
    poke(rect+5,floor(tx/256))      
    poke(rect+6,and_bits(ty,255))      
    poke(rect+7,floor(ty/256))      

end procedure

--------------------------------------------------------------------

procedure init()
	    
    dummy = SDL_Init(SDL_INIT_VIDEO+SDL_INIT_TIMER)
    if dummy = -1 then
        puts(1, "SDL_Init had a hissy fit!\n")
    end if

    surface = SDL_SetVideoMode(800,600,16,SDL_FULLSCREEN)

    format=peek4u(surface+4)
    pixels=peek4u(surface+20)

    srect=allocate(8)

    drect=allocate(8)

    mx=allocate(4)
    my=allocate(4)

    backs=SDL_LoadBMP("Bitmaps/back1.bmp")
    balls=SDL_LoadBMP("Bitmaps/bounds.bmp")
	dummy=SDL_SetColorKey(balls,SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
    if dummy = -1 then
        puts(1, "SDL_SetColorKey had a hissy fit!\n")
    end if

    buffer = SDL_ConvertSurface(surface,format,SDL_SWSURFACE)
    back = SDL_ConvertSurface(surface,format,SDL_SWSURFACE)
    back2 = SDL_ConvertSurface(surface,format,SDL_SWSURFACE)
    back3 = SDL_ConvertSurface(surface,format,SDL_SWSURFACE)
	dummy=SDL_SetColorKey(back3,SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
    if dummy = -1 then
       puts(1, "SDL_SetColorKey had a hissy fit!\n")
    end if
	dummy=SDL_SetAlpha(back2,SDL_SRCALPHA,30)
	if dummy = -1 then
	   	puts(1, "SDL_SetAlpha had a hissy fit!\n")
	end if
       				
end procedure

--------------------------------------------------------------------

procedure new_round()

integer ox
-- draw the background

	calc_rect(srect,0,0,84,74)
    for x1=0 to 800 by 84 do
		ox=remainder((x1/84),2)*37
        for y1=(0-ox) to (526+ox) by 74 do
		    calc_rect(drect,x1,y1,84,74)
			dummy=SDL_BlitSurface(backs,srect,back,drect)
			if dummy = -1 then
					puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
			end if
        end for
    end for

    nt=rand(4)+1
    tl=rand(5)+7
    c=1
    a=0
    ai=rand(100)+40
    ai/=1000
    am=rand(45)
    am/=10
    ad=(PI*2)/nt
	bb=rand(3)-1

end procedure

--------------------------------------------------------------------

procedure cleanup()
   
-- We're done with them.. Free the surfaces
    SDL_FreeSurface(surface)
    SDL_FreeSurface(buffer)
    SDL_FreeSurface(back)
    SDL_FreeSurface(back2)
    SDL_FreeSurface(back3)
    SDL_FreeSurface(backs)
    SDL_FreeSurface(balls)

    free(srect)
    free(drect)
    free(mx)
    free(my)

-- quit SDL
    SDL_Quit()   
        
end procedure

--------------------------------------------------------------------

procedure main()

	integer done
	integer ticks1,ticks2,ticks
	
	new_round()

	dummy=SDL_FillRect(back2,NULL,0)
	done=0

	while not done do
		ticks1=SDL_GetTicks()
	   	SDL_PumpEvents()
    	keystate=SDL_GetKeyState(NULL)
    	if peek(keystate+SDLK_ESCAPE)>0 then
				done=1        
		end if
		gmouse=SDL_GetMouseState(mx,my)
		if gmouse = -1 then
			puts(1, "SDL_GetMouseState had a hissy fit!\n")
		end if
		if gmouse=1 then
			done=1        
		end if
		if gmouse=4 then
        	new_round()
		end if

		dummy=SDL_BlitSurface(back,NULL,buffer,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if

		dummy=SDL_BlitSurface(back2,NULL,back3,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if

        d=sin(a*am)*80
        d+=150        
        cc=c+1
        if cc>12 then
        	cc-=12    
		end if
        for j=1 to nt do
            x=cos(a+(j*ad))*d+375
            y=sin(a+(j*ad))*d+275
			calc_rect(drect,floor(x),floor(y),25,25)
            if  cc=1 then
				calc_rect(srect,bb*100,0,25,25)
            elsif cc=2 then
				calc_rect(srect,25+bb*100,0,25,25)
            elsif cc=3 then
				calc_rect(srect,50+bb*100,0,25,25)
            elsif cc=4 then
				calc_rect(srect,75+bb*100,0,25,25)
            elsif cc=5 then
				calc_rect(srect,bb*100,25,25,25)
            elsif cc=6 then
				calc_rect(srect,25+bb*100,25,25,25)
            elsif cc=7 then
				calc_rect(srect,50+bb*100,25,25,25)
            elsif cc=8 then
				calc_rect(srect,75+bb*100,25,25,25)
           	elsif cc=9 then
				calc_rect(srect,bb*100,50,25,25)
           	elsif cc=10 then
				calc_rect(srect,25+bb*100,50,25,25)
           	elsif cc=11 then
				calc_rect(srect,50+bb*100,50,25,25)
            elsif cc=12 then
				calc_rect(srect,75+bb*100,50,25,25)
            end if
			dummy=SDL_BlitSurface(balls,srect,back3,drect)
			if dummy = -1 then
				puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
			end if
        end for

		dummy=SDL_BlitSurface(back3,NULL,buffer,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if

		dummy=SDL_BlitSurface(buffer,NULL,surface,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if

		SDL_UpdateRect(surface,0,0,0,0)

	    a+=ai
    	if a>15 then
        	new_round()
    	end if
    	c+=1
   		c=remainder(c,12)    

		ticks=0
		while ticks<68 do
			ticks2=SDL_GetTicks()
			ticks=ticks2-ticks1
		end while
    
	end while

end procedure

--------------------------------------------------------------------

init()
main()
cleanup()






