-- SDLEX03.EX
-- Flip pages to make the mystic ellipses
-- Converted from an earlier PTC demo

include misc.e
include file.e
include machine.e
include Sdl_Wrap.e

atom format,pixels,dummy  
atom surface,buffer,back,back2,back3
atom keystate
integer done
integer x,y
integer dx,dy,dxx,dyy
atom xx,yy
atom a,aa
sequence cos1
sequence sin1
atom srect,drect
atom mx,my
atom backs

--------------------------------------------------------------------

procedure calc_rect(atom rect, integer sx, integer sy, integer tx, integer ty)

    poke(rect,and_bits(sx,255))      
    poke(rect+1,floor(sx/256))      
    poke(rect+2,and_bits(sy,255))      
    poke(rect+3,floor(sy/256))      
    poke(rect+4,and_bits(tx,255))      
    poke(rect+5,floor(tx/256))      
    poke(rect+6,and_bits(ty,255))      
    poke(rect+7,floor(ty/256))      

end procedure

--------------------------------------------------------------------

procedure init()
	    
    dummy = SDL_Init(SDL_INIT_VIDEO+SDL_INIT_TIMER)
    if dummy = -1 then
        puts(1, "SDL_Init had a hissy fit!\n")
    end if

    surface = SDL_SetVideoMode(640,480,16,SDL_FULLSCREEN)

    format=peek4u(surface+4)
    pixels=peek4u(surface+20)

    srect=allocate(8)

    drect=allocate(8)

    mx=allocate(4)
    my=allocate(4)

    backs=SDL_LoadBMP("Bitmaps/back2.bmp")

    buffer = SDL_ConvertSurface(surface,format,SDL_SWSURFACE)
    back = SDL_ConvertSurface(surface,format,SDL_SWSURFACE)
    back2 = SDL_ConvertSurface(surface,format,SDL_SWSURFACE)
    back3 = SDL_ConvertSurface(surface,format,SDL_SWSURFACE)
	dummy=SDL_SetColorKey(back3,SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
    if dummy = -1 then
       puts(1, "SDL_SetColorKey had a hissy fit!\n")
    end if
	dummy=SDL_SetAlpha(back2,SDL_SRCALPHA,18)
	if dummy = -1 then
	   	puts(1, "SDL_SetAlpha had a hissy fit!\n")
	end if
       				
	cos1=repeat(0,768)    
	sin1=repeat(0,768)    

	for j=0 to 767 do
	   	cos1[j+1]=cos(j*PI*2/768)
  		sin1[j+1]=sin(j*PI*2/768)
	end for

	calc_rect(srect,0,0,96,96)
    for x1=0 to 600 by 96 do
        for y1=0 to 400 by 96 do
		    calc_rect(drect,x1,y1,96,96)
			dummy=SDL_BlitSurface(backs,srect,back,drect)
			if dummy = -1 then
				puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
			end if
        end for
    end for
	dummy=SDL_SetColorKey(backs,SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
    if dummy = -1 then
       puts(1, "SDL_SetColorKey had a hissy fit!\n")
    end if
	for i=1 to 40 do
		calc_rect(drect,rand(640),rand(480),96,96)
		dummy=SDL_BlitSurface(backs,srect,back,drect)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if
	end for

end procedure

--------------------------------------------------------------------

procedure cleanup()
   
-- We're done with them.. Free the surfaces
    SDL_FreeSurface(surface)
    SDL_FreeSurface(buffer)
    SDL_FreeSurface(back)
    SDL_FreeSurface(back2)
    SDL_FreeSurface(back3)
    SDL_FreeSurface(backs)

    free(srect)
    free(drect)
    free(mx)
    free(my)

-- quit SDL
    SDL_Quit()   
        
end procedure

--------------------------------------------------------------------

procedure main()

	integer r,g,b
	integer ticks1,ticks2,ticks

	a=0
	aa=.04
	dx=rand(170)+50
	dy=rand(180)+50
	dxx=4
	dyy=-5

	done=0    
	dummy=SDL_FillRect(back2,NULL,0)

	while done=0 do
		ticks1=SDL_GetTicks()
    	SDL_PumpEvents()
    	keystate=SDL_GetKeyState(NULL)
    	if peek(keystate+SDLK_ESCAPE)>0 then
        	done=1        
    	end if
    	SDL_PumpEvents()
    	dummy=SDL_GetMouseState(0,0)
    	if dummy = -1 then
        	puts(1, "SDL_GetMouseState had a hissy fit!\n")
    	end if
    	if dummy>0 then
        	done=1    
    	end if
    
		dummy=SDL_BlitSurface(back,NULL,buffer,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if

		dummy=SDL_BlitSurface(back2,NULL,back3,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if

	    a += aa
    	if a>(PI*2) then
        	a -= (PI*2)    
    	end if
    	if a<0 then 
        	a += (PI*2)    
    	end if

	    if rand(500)>499 then
    	    aa=aa*-1    
    	end if

	    if rand(300)>299 then
    	    dxx=dxx*-1    
    	end if

	    if rand(300)>299 then
    	    dyy=dyy*-1    
    	end if

	    dx += dxx
    	if dx>234 then
        	dx=234
        	dxx = -4    
    	end if
    	if dx<20 then
        	dx=20
        	dxx = 4   
    	end if           

	    dy += dyy
    	if dy>234 then
        	dy=234
        	dyy = -5    
    	end if
    	if dy<30 then
        	dy=30
        	dyy = 5   
    	end if           
      
-- draw ellipse pixels

	    for j=0 to 767 do

			if j<128 then
				r=255
   			    g=remainder(j,128)*2
				b=0
			else
				if j<256 then
					r=255-remainder(j,128)*2
   				    g=255
					b=0
				else
					if j<384 then
						r=0
   				    	g=255
						b=remainder(j,128)*2
					else
						if j<512 then
							r=0
   						    g=255-remainder(j,128)*2
							b=255
						else
							if j<640 then
								r=remainder(j,128)*2
   						    	g=0
								b=255
							else
								r=255
   						    	g=0
								b=255-remainder(j,128)*2
							end if
						end if
					end if
				end if
			end if

	        xx = cos1[j+1]*dx
	        yy = sin1[j+1]*dy

    	    x = floor(xx*cos(a)+yy*sin(a)+.5)
	        y = floor(yy*cos(a)-xx*sin(a)+.5)
            
        	x += 320
        	y += 240
                       
     		calc_rect(drect,x,y,1,1)
			dummy=SDL_FillRect(back3,drect,SDL_MapRGB(format,r,g,b))

	    end for

		dummy=SDL_BlitSurface(back3,NULL,buffer,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if

		dummy=SDL_BlitSurface(buffer,NULL,surface,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if
    	SDL_UpdateRect(surface,0,0,0,0)

		ticks=0
		while ticks<65 do
			ticks2=SDL_GetTicks()
			ticks=ticks2-ticks1
		end while

	end while

end procedure

--------------------------------------------------------------------

init()
main()
cleanup()


