-- Fireworks.EX
-- More alpha blending fun... Pyrotechnics for your PC
-- Written in Euphoria
-- This program uses SDL_Wrap 
-- Mark K. Akita   2/24/03

without type_check

include file.e
include machine.e
include Sdl_Wrap.e
include misc.e

atom format,pixels
atom dummy
atom keystate
atom surface,buffer,back
atom star
atom srect,drect
atom mx,my
integer gmouse
sequence fc
sequence ft
sequence fx
sequence fy
sequence fxx
sequence fyy
sequence fc2
sequence ft2
sequence fx2
sequence fy2
sequence fxx2
sequence fyy2

--------------------------------------------------------------------

function abs(atom i)
	if i<0 then
        return -i
    else
        return i 
    end if
end function

--------------------------------------------------------------------

procedure newbie()

		ft=ft&{-1}
		fc=fc&{rand(5)}
		fx=fx&{rand(320)+160}
		fy=fy&{472}
		if rand(2)-1 then
 			fxx=fxx&{rand(100)/60}
		else
			fxx=fxx&{-(rand(100)/60)}
		end if
		fyy=fyy&{-(5+(rand(200)/100))}

end procedure

--------------------------------------------------------------------

procedure newbie2(integer o)

	for i=1 to 8+rand(10) do
		ft=ft&{30+rand(20)}
		fc=fc&{fc[o]}
		fx=fx&{fx[o]}
		fy=fy&{fy[o]}
		if rand(2)-1 then
 			fxx=fxx&{rand(180)/60}
		else
			fxx=fxx&{-(rand(180)/60)}
		end if
		if rand(2)-1 then
			fyy=fyy&{rand(175)/60}
		else
			fyy=fyy&{-rand(185)/60}
		end if
	end for
		
end procedure

--------------------------------------------------------------------

procedure init()
    
    dummy = SDL_Init(SDL_INIT_VIDEO+SDL_INIT_TIMER)
    if dummy = -1 then
        puts(1, "SDL_Init had a hissy fit!\n")
    end if

    surface = SDL_SetVideoMode(640,480,16,SDL_FULLSCREEN)

    format=peek4u(surface+4)
    pixels=peek4u(surface+20)

    srect=allocate(8)

    drect=allocate(8)

    mx=allocate(4)
    my=allocate(4)

    back = SDL_ConvertSurface(surface,format,SDL_HWSURFACE)
    buffer = SDL_ConvertSurface(surface,format,SDL_HWSURFACE)
    star=SDL_LoadBMP("Bitmaps/star.bmp")
	dummy=SDL_SetColorKey(star,SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
    if dummy = -1 then
        puts(1, "SDL_SetColorKey had a hissy fit!\n")
    end if

	dummy=SDL_SetAlpha(back,SDL_SRCALPHA,30)
	if dummy = -1 then
	   	puts(1, "SDL_SetAlpha had a hissy fit!\n")
	end if

	ft={}
	fc={}
	fx={}
	fy={}
	fxx={}
	fyy={}

	for i=1 to 2 do
		newbie()
	end for
	       				
end procedure

--------------------------------------------------------------------

procedure calc_rect(atom rect, integer sx, integer sy, integer tx, integer ty)

    poke(rect,and_bits(sx,255))      
    poke(rect+1,floor(sx/256))      
    poke(rect+2,and_bits(sy,255))      
    poke(rect+3,floor(sy/256))      
    poke(rect+4,and_bits(tx,255))      
    poke(rect+5,floor(tx/256))      
    poke(rect+6,and_bits(ty,255))      
    poke(rect+7,floor(ty/256))      

end procedure

--------------------------------------------------------------------

procedure cleanup()
   
-- We're done with them.. Free the surfaces
    SDL_FreeSurface(surface)
    SDL_FreeSurface(buffer)
    SDL_FreeSurface(back)
    SDL_FreeSurface(star)

    free(srect)
    free(drect)
    free(mx)
    free(my)

-- quit SDL
    SDL_Quit()   
        
end procedure

--------------------------------------------------------------------

procedure main()

	atom done
	integer ix,iy
	integer ticks1,ticks2,ticks
	
	dummy=SDL_FillRect(back,NULL,0)

	done=0    
	while not done do
		ticks1=SDL_GetTicks()
	   	SDL_PumpEvents()
    	keystate=SDL_GetKeyState(NULL)
    	if peek(keystate+SDLK_ESCAPE)>0 then
				done=1        
		end if
		gmouse=SDL_GetMouseState(mx,my)
		if gmouse = -1 then
			puts(1, "SDL_GetMouseState had a hissy fit!\n")
		end if
		if gmouse=1 then
				done=1        
		end if

		dummy=SDL_BlitSurface(back,NULL,buffer,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if

		fx+=fxx
		fy+=fyy
		fyy+=.05

		for i=1 to length(ft) do
			if ft[i] then
				ix=floor(fx[i])		
				iy=floor(fy[i])		
				calc_rect(srect,fc[i]*7-7,0,7,7)
	    		calc_rect(drect,ix,iy,7,7)
				dummy=SDL_BlitSurface(star,srect,buffer,drect)
				if dummy = -1 then
					puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
				end if
			end if
		end for

		for i=1 to length(ft) do
			if ft[i]=-1 then
				if fyy[i]>1 then
					newbie2(i)
					ft[i]=0
				end if
			end if
			if ft[i]>0 then
				ft[i]-=1
			end if
		end for

		ft2={}
		fc2={}
		fx2={}
		fy2={}
		fxx2={}
		fyy2={}
		for i=1 to length(ft) do
			if ft[i] then
				ft2=ft2&{ft[i]}
				fc2=fc2&{fc[i]}
				fx2=fx2&{fx[i]}
				fy2=fy2&{fy[i]}
				fxx2=fxx2&{fxx[i]}
				fyy2=fyy2&{fyy[i]}
			end if
		end for
		
		ft=ft2
		fc=fc2
		fx=fx2
		fy=fy2
		fxx=fxx2
		fyy=fyy2

		if rand(100)>97 then
			newbie()
		end if

		dummy=SDL_BlitSurface(buffer,NULL,surface,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if
		SDL_UpdateRect(surface,0,0,0,0)

		ticks=0
		while ticks<40 do
			ticks2=SDL_GetTicks()
			ticks=ticks2-ticks1
		end while

	end while

end procedure

--------------------------------------------------------------------

init()
main()
cleanup()



