-- Life_SDL.EX
-- The ever classic game of life... 
-- Written in Euphoria
-- This program uses the SDL_Wrap 
-- Mark K. Akita   2/25/03

without type_check

include file.e
include machine.e
include Sdl_Wrap.e
include misc.e

atom format,pixels
atom dummy
atom keystate
atom surface,buffer,back
atom srect,drect
atom mx,my
integer gmouse
sequence s1,s2,s3,s4
integer count
integer x1,y1,x2,y2

--------------------------------------------------------------------

function abs(atom i)
	if i<0 then
        return -i
    else
        return i 
    end if
end function

--------------------------------------------------------------------

procedure init()
	    
    dummy = SDL_Init(SDL_INIT_VIDEO+SDL_INIT_TIMER)
    if dummy = -1 then
        puts(1, "SDL_Init had a hissy fit!\n")
    end if

    surface = SDL_SetVideoMode(640,480,16,SDL_FULLSCREEN)

    format=peek4u(surface+4)
    pixels=peek4u(surface+20)

    srect=allocate(8)

    drect=allocate(8)

    mx=allocate(4)
    my=allocate(4)

    buffer = SDL_ConvertSurface(surface,format,SDL_HWSURFACE)
    back = SDL_ConvertSurface(surface,format,SDL_HWSURFACE)

	dummy=SDL_SetAlpha(back,SDL_SRCALPHA,90)
	if dummy = -1 then
	   	puts(1, "SDL_SetAlpha had a hissy fit!\n")
	end if
       				
end procedure

--------------------------------------------------------------------

procedure new_life()

    s1=repeat(repeat(0,320),200)
    s2=s1
    s3=s1
    
    for x=50 to 270 do
        for y=50 to 150 do
			if rand(3)=2 then
				s1[y][x]=1
			end if            
    	end for
    end for
 
    count=2000

    for x=1 to 320 do
        for y=1 to 200 do
            if s1[y][x] then
                x1=remainder(x+318,320)+1
                x2=remainder(x+320,320)+1
                y1=remainder(y+198,200)+1
                y2=remainder(y+200,200)+1
                s3[y1][x1] += 1
                s3[y1][x] += 1
                s3[y1][x2] += 1
                s3[y][x1] += 1
                s3[y][x2] += 1
                s3[y2][x1] += 1
                s3[y2][x] += 1
                s3[y2][x2] += 1
            end if
        end for
    end for

end procedure

--------------------------------------------------------------------

procedure calc_rect(atom rect, integer sx, integer sy, integer tx, integer ty)

    poke(rect,and_bits(sx,255))      
    poke(rect+1,floor(sx/256))      
    poke(rect+2,and_bits(sy,255))      
    poke(rect+3,floor(sy/256))      
    poke(rect+4,and_bits(tx,255))      
    poke(rect+5,floor(tx/256))      
    poke(rect+6,and_bits(ty,255))      
    poke(rect+7,floor(ty/256))      

end procedure

--------------------------------------------------------------------

procedure cleanup()
   
-- We're done with them.. Free the surfaces
    SDL_FreeSurface(surface)
    SDL_FreeSurface(buffer)
    SDL_FreeSurface(back)

    free(srect)
    free(drect)
    free(mx)
    free(my)

-- quit SDL
    SDL_Quit()   
        
end procedure

--------------------------------------------------------------------

procedure main()

	atom done
	integer mx2,my2
	integer r,g,b,n				
	integer c,cc
	integer ticks1,ticks2,ticks

    dummy=SDL_FillRect(back,NULL,0)
	done=0
	c=0    
	while done=0 do

		ticks1=SDL_GetTicks()
		c+=1
		c=remainder(c,384)
    	SDL_PumpEvents()
    	keystate=SDL_GetKeyState(NULL)
    	if peek(keystate+SDLK_ESCAPE)>0 then
				done=1        
		end if
		gmouse=SDL_GetMouseState(mx,my)
		if gmouse = -1 then
			puts(1, "SDL_GetMouseState had a hissy fit!\n")
		end if
		mx2=peek(mx)+256*peek(mx+1)
		my2=peek(my)+256*peek(my+1)
		if gmouse=1 then
			done=1        
		end if
		if gmouse=4 then
			new_life()        
		end if

		dummy=SDL_BlitSurface(back,NULL,buffer,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if

	    s2=s1

	    s4=repeat(repeat(0,320),200)

		for y=1 to 200 do
			cc=remainder(c+y,384)
			if cc<64 then
				r=255
   		    	g=remainder(cc,64)*4
				b=0
			else
				if cc<128 then
					r=255-remainder(cc,64)*4
   			    	g=255
					b=0
				else
					if cc<192 then
						r=0
   			   			g=255
						b=remainder(cc,64)*4
					else
						if cc<256 then
							r=0
   			    			g=255-remainder(cc,64)*4
							b=255
						else
							if cc<320 then
								r=remainder(cc,64)*4
   						    	g=0
								b=255
							else
								r=255
   					   			g=0
								b=255-remainder(cc,64)*4
							end if
						end if
					end if
				end if
			end if
	    	for x=1 to 320 do
        	    n=s3[y][x]
            	if n>3 then
                	s2[y][x]=0
	            else
    	            if n<2 then
        	            s2[y][x]=0
            	    else
                	    if n=3 and s2[y][x]=0 then
	                        s2[y][x]=1    
    	                end if
        	        end if
            	end if

            	if s2[y][x] then
    				calc_rect(drect,x*2,y*2+40,2,2)
					dummy=SDL_FillRect(buffer,drect,SDL_MapRGB(format,r,g,b))
					if dummy = -1 then
						puts(1, "SDL_FillRect had a hissy fit!\n")
					end if
                	x1=remainder(x+318,320)+1
                	x2=remainder(x+320,320)+1
                	y1=remainder(y+198,200)+1
                	y2=remainder(y+200,200)+1
                	s4[y1][x1] += 1
                	s4[y1][x] += 1
                	s4[y1][x2] += 1
                	s4[y][x1] += 1
                	s4[y][x2] += 1
    	            s4[y2][x1] += 1
        	        s4[y2][x] += 1
            	    s4[y2][x2] += 1
            	end if
	        end for
	    end for

	    s1=s2
    	s3=s4

		dummy=SDL_BlitSurface(buffer,NULL,surface,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if
		SDL_UpdateRect(surface,0,0,0,0)

	    count=count-1
    	if count<1 then
        	new_life()
    	end if

		ticks=0
		while ticks<80 do
			ticks2=SDL_GetTicks()
			ticks=ticks2-ticks1
		end while

	end while

end procedure

--------------------------------------------------------------------

init()
new_life()
main()
cleanup()


