-- Mathpic_SDL.EX
-- A classic concept redone once more
-- Written in Euphoria
-- This program uses the SDL_Wrap 
-- Mark K. Akita   2/20/02

include file.e
include machine.e
include Sdl_Wrap.e
include misc.e

atom format,pixels
atom dummy
atom keystate
atom surface,back
atom srect,drect
atom mx,my
integer gmouse

--------------------------------------------------------------------

function mp(integer x, integer y, integer ox, integer oy, integer n)
    
    atom a,xx,yy
        
    if n=1 then
        return remainder(x,256)
    end if 
    if n=2 then
        return remainder(y,256)
    end if
    if n=3 then
        return floor(sin((x+ox)*PI/128)*127+128)
    end if 
    if n=4 then
        return floor(sin((y+oy)*PI/128)*127+128)
    end if 
    if n=5 then
        return remainder(x+ox-y+oy+256,256)
    end if 
    if n=6 then
        return floor(sin((x+ox-y+oy)*PI/128)*127+128)
    end if 
    if n=7 then
        return remainder(x+ox+y+oy,256)
    end if 
    if n=8 then
        return floor(sin((x+ox+y+oy)*PI/128)*127+128)
    end if 
    if n=9 then
        return remainder(floor(sqrt((ox-x)*(ox-x)+(oy-y)*(oy-y))),256)
    end if    
    if n=10 then
        return floor(sin(sqrt((ox-x)*(ox-x)+(oy-y)*(oy-y))*PI/32)*127+128)
    end if 
    if n=11 then
        xx = x - ox
        yy = y - oy
        if yy != 0 then
            a = arctan(xx / yy) + PI / 2
        else
            a = 0
        end if
        return floor(cos(a * 2) * 127 + 128)
    end if
end function

--------------------------------------------------------------------

procedure init()
    
    dummy = SDL_Init(SDL_INIT_VIDEO)
    if dummy = -1 then
        puts(1, "SDL_Init had a hissy fit!\n")
    end if

    surface = SDL_SetVideoMode(640,480,16,SDL_FULLSCREEN)

    format=peek4u(surface+4)
    pixels=peek4u(surface+20)

    srect=allocate(8)

    drect=allocate(8)

    mx=allocate(4)
    my=allocate(4)

    back = SDL_ConvertSurface(surface,format,SDL_HWSURFACE)       				

end procedure

--------------------------------------------------------------------

procedure calc_rect(atom rect, integer sx, integer sy, integer tx, integer ty)

    poke(rect,and_bits(sx,255))      
    poke(rect+1,floor(sx/256))      
    poke(rect+2,and_bits(sy,255))      
    poke(rect+3,floor(sy/256))      
    poke(rect+4,and_bits(tx,255))      
    poke(rect+5,floor(tx/256))      
    poke(rect+6,and_bits(ty,255))      
    poke(rect+7,floor(ty/256))      

end procedure

--------------------------------------------------------------------

procedure cleanup()
   
-- We're done with them.. Free the surfaces
    SDL_FreeSurface(surface)
    SDL_FreeSurface(back)

    free(srect)
    free(drect)
    free(mx)
    free(my)

-- quit SDL
    SDL_Quit()   
        
end procedure

--------------------------------------------------------------------

procedure drawit()

	integer c,n1,ox1,oy1,n2,ox2,oy2,n3,ox3,oy3
	integer cc,r,g,b

	ox1=rand(640)-1
	oy1=rand(480)-1
	n1=rand(3)+8
	ox2=rand(640)-1
	oy2=rand(480)-1
	n2=rand(7)+4
	ox3=rand(640)-1
	oy3=rand(480)-1
	n3=rand(10)
	cc=rand(7)

	for y=0 to 479 do
        for x=0 to 639 do
        	c=mp(x,y,ox1,oy1,n1)
            c=c+mp(x,y,ox2,oy2,n2)
            c=c+mp(x,y,ox3,oy3,n3)
            c=remainder(c,256)
			if cc=1 then
				r=c
				g=c
				b=c
			end if
			if cc=2 then
				r=c
				g=0
				b=0
			end if
			if cc=3 then
				r=c
				g=floor(c/2)
				b=0
			end if
			if cc=4 then
				r=c
				g=c
				b=0
			end if
			if cc=5 then
				r=0
				g=c
				b=0
			end if
			if cc=6 then
				r=0
				g=0
				b=c
			end if
			if cc=7 then
				r=c
				g=0
				b=c
			end if
    		calc_rect(drect,x,y,1,1)
			dummy=SDL_FillRect(back,drect,SDL_MapRGB(format,r,g,b))
			if dummy = -1 then
				puts(1, "SDL_FillRect had a hissy fit!\n")
			end if
		end for
    	SDL_PumpEvents()
    	keystate=SDL_GetKeyState(NULL)
    	if peek(keystate+SDLK_ESCAPE)>0 then
				exit        
		end if
		gmouse=SDL_GetMouseState(mx,my)
		if gmouse = -1 then
			puts(1, "SDL_GetMouseState had a hissy fit!\n")
		end if
		if gmouse=1 then
				exit       
		end if
	end for               
	
	dummy=SDL_BlitSurface(back,NULL,surface,NULL)
	if dummy = -1 then
		puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
	end if
	SDL_UpdateRect(surface,0,0,0,0)

end procedure

--------------------------------------------------------------------

procedure main()

	atom done

	done=0    
	while done=0 do
		drawit()
    	SDL_PumpEvents()
    	keystate=SDL_GetKeyState(NULL)
    	if peek(keystate+SDLK_ESCAPE)>0 then
				done=1        
		end if
		gmouse=SDL_GetMouseState(mx,my)
		if gmouse = -1 then
			puts(1, "SDL_GetMouseState had a hissy fit!\n")
		end if
		if gmouse=1 then
				done=1        
		end if
	end while

end procedure

--------------------------------------------------------------------

init()
main()
cleanup()


