-- Plasma1.EX					
-- Special Effects using 8-bit palette graphics
-- Written in Euphoria
-- Mark K. Akita   3/18/03

include file.e
include machine.e
include Sdl_Wrap.e
include misc.e

atom format,pixels
atom format2,pixels2
atom dummy
atom keystate
atom surface,buffer,back
atom srect,drect
atom mx,my
atom pal1
integer gmouse
sequence p1
sequence div9
atom s1
integer px,py,pxx,pyy,ty,dx,dy,z,zz

--------------------------------------------------------------------

function abs(atom i)
	if i<0 then
        return -i
    else
        return i 
    end if
end function

--------------------------------------------------------------------

procedure init()
    
    dummy = SDL_Init(SDL_INIT_VIDEO+SDL_INIT_TIMER)
    if dummy = -1 then
        puts(1, "SDL_Init had a hissy fit!\n")
    end if

    surface = SDL_SetVideoMode(640,480,8,SDL_FULLSCREEN+SDL_HWPALETTE)

    format=peek4u(surface+4)
    pixels=peek4u(surface+20)

    srect=allocate(8)
    drect=allocate(8)

    mx=allocate(4)
    my=allocate(4)

    back = SDL_ConvertSurface(surface,format,SDL_HWSURFACE)
    buffer = SDL_ConvertSurface(surface,format,SDL_HWSURFACE)

    format2=peek4u(back+4)
    pixels2=peek4u(back+20)

	s1=allocate(307200)       				

	div9=repeat(0,2304)
	for i=1 to 2304 do
		div9[i]=floor(i/9)
	end for

end procedure

--------------------------------------------------------------------

procedure newbie()

	integer r

	pal1=allocate(1024)       				
	p1=repeat(0,1024)
	r=rand(6)

	for i=0 to 127 do
		if r=1 then
			p1[(i*4)+3]=i*2
			p1[(i*4)+515]=255
			p1[(i*4)+514]=i*2
		end if
		if r=2 then
			p1[(i*4)+2]=i*2
			p1[(i*4)+514]=255
			p1[(i*4)+515]=i*2
		end if
		if r=3 then
			p1[(i*4)+1]=i*2
			p1[(i*4)+513]=255
			p1[(i*4)+515]=i*2
		end if
		if r=4 then
			p1[(i*4)+2]=i*2
			p1[(i*4)+514]=255
			p1[(i*4)+513]=i*2
		end if
		if r=5 then
			p1[(i*4)+3]=i*2
			p1[(i*4)+515]=255
			p1[(i*4)+513]=i*2
		end if
		if r=6 then
			p1[(i*4)+1]=i*2
			p1[(i*4)+513]=255
			p1[(i*4)+514]=i*2
		end if
	end for

	poke(pal1,p1)
	dummy=SDL_SetPalette(surface,SDL_PHYSPAL,pal1,0,256)
	if dummy = -1 then
		puts(1, "SDL_SetPalette had a hissy fit!\n")
	end if
	dummy=SDL_SetPalette(back,SDL_PHYSPAL,pal1,0,256)
	if dummy = -1 then
		puts(1, "SDL_SetPalette had a hissy fit!\n")
	end if
		
	px=rand(319)*2
	py=rand(100)+139
	pxx=rand(5)+3
	pyy=rand(8)*(rand(3)-2)
	ty=rand(20)*2+10
	z=rand(639)
	zz=rand(3)-2

end procedure

--------------------------------------------------------------------

procedure calc_rect(atom rect, integer sx, integer sy, integer tx, integer ty)

    poke(rect,and_bits(sx,255))      
    poke(rect+1,floor(sx/256))      
    poke(rect+2,and_bits(sy,255))      
    poke(rect+3,floor(sy/256))      
    poke(rect+4,and_bits(tx,255))      
    poke(rect+5,floor(tx/256))      
    poke(rect+6,and_bits(ty,255))      
    poke(rect+7,floor(ty/256))      

end procedure

--------------------------------------------------------------------

procedure cleanup()
   
-- We're done with them.. Free the surfaces
    SDL_FreeSurface(surface)
    SDL_FreeSurface(buffer)
    SDL_FreeSurface(back)

    free(srect)
    free(drect)
    free(mx)
    free(my)
    free(pal1)
    free(s1)

-- quit SDL
    SDL_Quit()   
        
end procedure

--------------------------------------------------------------------

procedure main()

	atom done
	integer a,t,t2
	sequence ss1,ss2,ss3,ss4,ss5,ss6	
	integer ticks1,ticks2,ticks

	dummy=SDL_FillRect(back,NULL,0)
	done=0
	while done=0 do
		ticks1=SDL_GetTicks()		
    	SDL_PumpEvents()
    	keystate=SDL_GetKeyState(NULL)
    	if peek(keystate+SDLK_ESCAPE)>0 then
				done=1        
		end if
		gmouse=SDL_GetMouseState(mx,my)
		if gmouse = -1 then
			puts(1, "SDL_GetMouseState had a hissy fit!\n")
		end if
		if gmouse=1 then
				done=1        
		end if

	
		mem_copy(pixels2,s1,307200)

		dummy=SDL_BlitSurface(back,NULL,buffer,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if
	
		dx=floor(cos(((px+z)/640)*PI)*py)
		dy=floor(sin(((px+z)/640)*PI)*py)+ty
		calc_rect(drect,318-abs(dx),238-abs(dy),6,6)
		dummy=SDL_FillRect(back,drect,255)
		calc_rect(drect,318-abs(dy),238-abs(dx),6,6)
		dummy=SDL_FillRect(back,drect,255)
		ss1=peek({pixels2,640})
		ss2=peek({pixels2+1280,640})
		t=-1
		t2=306559
		for y=4 to 242 by 2 do
			ss3=peek({pixels2+y*640-639,640})
			ss4=ss1+ss2+ss3
			ss5=ss4[3..640]&ss4[1..2]
			ss6=ss4[639..640]&ss4[1..638]
			ss4=ss4+ss5+ss6
			for x=2 to 320 by 2 do
				a=ss4[x]
				if a>0 then
					a=div9[a]
					if a<0 then
						a=0
					else
						if a>255 then
							a=255
						end if
					end if
				end if
				mem_set(s1+t+x,a,2)	
				mem_set(s1+t+x+640,a,2)	
				mem_set(s1+t+640-x,a,2)	
				mem_set(s1+t+1280-x,a,2)	
				mem_set(s1+t2+x,a,2)	
				mem_set(s1+t2+x-640,a,2)					
				mem_set(s1+t2+640-x,a,2)	
				mem_set(s1+t2-x,a,2)	
			end for
			t+=1280
			t2-=1280
			ss1=ss2
			ss2=ss3			
		end for

		px+=pxx
		py+=pyy
		z+=zz		

		if px<2 then
			px=2
			pxx=-pxx
		end if
		if px>638 then
			px=638
			pxx=-pxx
		end if
		if py<1 then
			py=2
			pyy=floor(-0.96*pyy)
			if abs(pyy)<2 then
				if rand(3)>1 then
					newbie()
				else
					pyy=rand(20)+15
				end if
			end if
		end if
		if py>238 then
			py=238
			pyy=-pyy
		end if
		if z>639 then
			z=z-640
		end if
		if z<0 then
 			z=z+640
		end if

		pyy=pyy-1

		dummy=SDL_BlitSurface(buffer,NULL,surface,NULL)
		if dummy = -1 then
			puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
		end if
		SDL_UpdateRect(surface,0,0,0,0)

		ticks=0
		while ticks<20 do
			ticks2=SDL_GetTicks()
			ticks=ticks2-ticks1
		end while

	end while

end procedure

--------------------------------------------------------------------

init()
newbie()
main()
cleanup()



