-- SDLEX02.EX
-- Simulate a Galton box, showing probability distributions

include misc.e
include file.e
include machine.e
include Sdl_Wrap.e

atom format,pixels,dummy,surface
atom r,done,srect,drect,pinbmp,surf2
atom back
integer xx,yy,nb
integer sx,sy
sequence ballbmp
sequence b_x,b_y,b_c
sequence gy

----------------------------------- 
dummy = SDL_Init(SDL_INIT_VIDEO)
if dummy = -1 then
    puts(1, "SDL_Init had a hissy fit!\n")
end if

surface = SDL_SetVideoMode(640,480,32,SDL_FULLSCREEN)

format=peek4u(surface+4)
pixels=peek4u(surface+20)

surf2 = SDL_ConvertSurface(surface,format,SDL_HWSURFACE)
back = SDL_ConvertSurface(surface,format,SDL_HWSURFACE)

ballbmp=repeat(0,3)

ballbmp[1]=SDL_LoadBMP("Bitmaps/Ball1.bmp")
ballbmp[2]=SDL_LoadBMP("Bitmaps/Ball2.bmp")
ballbmp[3]=SDL_LoadBMP("Bitmaps/Ball3.bmp")
pinbmp=SDL_LoadBMP("Bitmaps/pin.bmp")

dummy=SDL_ShowCursor(SDL_ENABLE)

srect=allocate(8)
drect=allocate(8)
poke(srect,0)
poke(srect+2,0)
poke(srect+4,20)
poke(srect+6,20)

for y=1 to 9 do
    for x=1 to y do
        yy=floor(y*20)
        xx=290-yy+floor(x*40)
        poke(drect,{remainder(xx,256),floor(xx/256),remainder(yy,256),floor(yy/256)})
        poke(drect+4,{20,0,20,0})
        dummy=SDL_BlitSurface(pinbmp,srect,back,drect)                                       
    end for
end for

b_x={}
b_y={}
b_c={}
gy=repeat(1,10)
nb=0

dummy = SDL_SetColorKey(ballbmp[1],SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
dummy = SDL_SetColorKey(ballbmp[2],SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
dummy = SDL_SetColorKey(ballbmp[3],SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))

done=0    

-- use the PumpEvents and GetMouseState to see if a mouse button has been pressed
while done=0 do
    SDL_PumpEvents()
    done=SDL_GetMouseState(0,0)
    if done = -1 then
        puts(1, "SDL_GetMouseState had a hissy fit!\n")
    end if
    poke(srect,{0,0,0,0})
    poke(srect+4,{128,2,224,1})
    poke(drect,{0,0,0,0})
    poke(drect+4,{128,2,224,1})
    dummy=SDL_BlitSurface(back,srect,surf2,drect)
    if nb<19 then
        nb=nb+1
        b_x=b_x&310
        b_y=b_y&0
        b_c=b_c&rand(3)    
    end if
    for i=1 to nb do
        poke(srect,{0,0,0,0})
        poke(srect+4,{20,0,20,0})
        poke(drect,{remainder(b_x[i],256),floor(b_x[i]/256),remainder(b_y[i],256),floor(b_y[i]/256)})
        poke(drect+4,{20,0,20,0})
        dummy=SDL_BlitSurface(ballbmp[b_c[i]],srect,surf2,drect)
        b_y[i]=b_y[i]+20
        if b_y[i]<200 then
            r=rand(2)
            if r=2 then
                b_x[i]=b_x[i]+20
            else
                b_x[i]=b_x[i]-20    
            end if
        end if
        if b_y[i]>450 then
            sx=floor((b_x[i]-90)/40)
            gy[sx]+=1
            if gy[sx]>180 then
                gy=repeat(1,10)    
            end if
            b_x[i]=310
            b_y[i]=0
            b_c[i]=rand(3)
        end if
    end for

    for i=1 to 10 do
        sx=i*40+90
        sy=479-gy[i]
        poke(drect,{0,0,0,0,20,0,0,0})
        poke(drect,{remainder(sx,256),floor(sx/256),remainder(sy,256),floor(sy/256)})
        poke(drect+6,{remainder(gy[i],256),floor(gy[i]/256)})
        dummy=SDL_FillRect(surf2,drect,SDL_MapRGB(format,0,0,255))
    end for

    SDL_UpdateRect(surf2,0,0,0,0)
    dummy=SDL_BlitSurface(surf2,NULL,surface,NULL)
    SDL_UpdateRect(surface,0,0,0,0)
    SDL_Delay(50)
end while

-- We're done with it.. Free the surface
SDL_FreeSurface(surface)
SDL_FreeSurface(surf2)
SDL_FreeSurface(back)
SDL_FreeSurface(pinbmp)
SDL_FreeSurface(ballbmp[1])
SDL_FreeSurface(ballbmp[2])
SDL_FreeSurface(ballbmp[3])

-- quit SDL
SDL_Quit()















