-- SDLEX03.EX
-- Flip pages to make the mystic ellipses
-- Converted from an earlier PTC demo

include misc.e
include file.e
include machine.e
include Sdl_Wrap.e

atom format,pixels,surface,console,dummy  
atom keystate
integer done
integer x,y
integer dx,dy,dxx,dyy
integer i
atom xx,yy
atom a,aa
sequence px,py
sequence col1
sequence cos1
sequence sin1
integer r,g,b,c
sequence cs


dummy = SDL_Init(SDL_INIT_VIDEO)
if dummy = -1 then
    puts(1, "SDL_Init had a hissy fit!\n")
end if
console = SDL_SetVideoMode(640,480,16,SDL_RESIZABLE)
format=peek4u(console+4)
surface = SDL_ConvertSurface(console,format,SDL_HWSURFACE)
pixels=peek4u(surface+20)

col1=repeat({0,0},768)    
cos1=repeat(0,768)    
sin1=repeat(0,768)    

for j=0 to 767 do
    i=floor(j/4)
           
    if i<32 then
        r = 31
        g = remainder(i,32)
        b = 0
        else
        if i>=32 and i<64 then
            r = 31-remainder(i,32)
            g = 31
            b = 0
        else
            if i>=64 and i<96 then
                r=0
                g=31
                b=remainder(i,32)
            else
                if i>=96 and i<128 then
                    r=0
                    g=31-remainder(i,32)
                    b=31
                else
                    if i>=128 and i<160 then
                        r=remainder(i,32)
                        g=0
                        b=31
                    else
                        r=31
                    g=0
                        b=31-remainder(i,32)    
                    end if
                end if
            end if                            
        end if
    end if

    c=SDL_MapRGB(format,r*8,g*8,b*8)
    cs=int_to_bytes(c)
    col1[j+1][1]=cs[1]
    col1[j+1][2]=cs[2]
    cos1[j+1]=cos(j*PI*2/768)
    sin1[j+1]=sin(j*PI*2/768)

end for

px=repeat(repeat(1,16),768)
py=repeat(repeat(1,16),768)
a=0
aa=.04
dx=rand(170)+50
dy=rand(180)+50
dxx=4
dyy=-5

done=0    
while done=0 do
    SDL_PumpEvents()
    keystate=SDL_GetKeyState(NULL)
    if peek(keystate+SDLK_ESCAPE)>0 then
        done=1        
    end if
    SDL_PumpEvents()
    dummy=SDL_GetMouseState(0,0)
    if dummy = -1 then
        puts(1, "SDL_GetMouseState had a hissy fit!\n")
    end if
    if dummy>0 then
        done=1    
    end if
    
    dummy=SDL_FillRect(surface,NULL,0)
        
    dummy=SDL_LockSurface(surface)
        if dummy = -1 then
        puts(1, "SDL_LockSurface had a hissy fit!\n")
    end if


    a += aa
    if a>(PI*2) then
        a -= (PI*2)    
    end if
    if a<0 then 
        a += (PI*2)    
    end if

    if rand(500)>499 then
        aa=aa*-1    
    end if

    if rand(300)>299 then
        dxx=dxx*-1    
    end if

    if rand(300)>299 then
        dyy=dyy*-1    
    end if

    dx += dxx
    if dx>234 then
        dx=234
        dxx = -4    
    end if
    if dx<20 then
        dx=20
        dxx = 4   
    end if           

    dy += dyy
    if dy>234 then
        dy=234
        dyy = -5    
    end if
    if dy<30 then
        dy=30
        dyy = 5   
    end if           
      
-- draw ellipse pixels

    for j=0 to 767 do

        i=floor(j/4)

        xx = cos1[j+1]*dx
        yy = sin1[j+1]*dy

        x = floor(xx*cos(a)+yy*sin(a)+.5)
        y = floor(yy*cos(a)-xx*sin(a)+.5)
            
        x += 320
        y += 240
            
        px[j+1]=px[j+1][2..16]&x
        py[j+1]=py[j+1][2..16]&y
           
        for k=1 to 16 do
            poke(pixels+(2*(py[j+1][k]*640+px[j+1][k])),col1[j+1])  
        end for

    end for

    SDL_UnlockSurface(surface)
    dummy=SDL_BlitSurface(surface,NULL,console,NULL)
    SDL_UpdateRect(console,0,0,0,0)
end while

SDL_FreeSurface(surface)
SDL_FreeSurface(console)




