-- SDLEX05.EX
-- Scrolling Map demo

include file.e
include machine.e
include Sdl_Wrap.e
include misc.e

atom format,pixels
atom dummy
atom surface
atom done
atom keystate
atom tiles
atom map
atom srect,drect
sequence world
integer px,py
integer xx,yy
integer c,t
integer cc

world={
"AAAAAAADDAAAFFDDFFFDDDDAACDDAAAAAADDAAAA",
"AAAAAADDDFFFFFFFFFFFDDDCCCDDAAAADDDCAAAA",
"AAAAAAADFFFFFFFDDDDDDDDACDDDAAEEAACCCAAA",
"AAAAAADDDFFFFFFFFDDDDDDACCDDAEEAAACCCAAA",
"AAAAACADFFFFFFFFFFDDDDDCCCDDAAAAACCAAAAA",
"AAAACCDFFFFFFCFFFDDDDDDDCDDDAAAAAACCCEEB",
"AAAACCDDFFFFFDFFFFFFFDDDDDDDDAAAAACCCEAB",
"CCAACCDFFFFFDDFFFFEEDDDDDDDDAAADDDDDCEEC",
"CCCBCCCDFFFFFFFFFFEEDDDDDCDAAAADDDDCCDDC",
"CCAAACDDFFFFFFFFFFDDDDDCCCDDAAAAAACCCDCC",
"CCCCACDDFFFFFFDDDDDDDDDCCCDDAABBAACCCDCC",
"CCCAAAADFFFFFFFDDDDDDDDDCCDDAABAAACCDCDD",
"CCCCCCCDFFFFCCFDDDDDFDDCFFDDDDAAFFFFDDDC",
"AAAAACDDFFFDCCFFDDDADDDCCCDDDFFFFFFFCCCF",
"AAAACCDDFFFDFFFFFFDAADDCCCDDAAAAAAFFCECC",
"AAACCCDDFFDFFFFDDDDDDDCCCCCDAAAAAAFFFFCC",
"AAAACCDDDDFFFFFFFFDDDDDDDCDDAAAAAACFFFFF",
"AAAACCDDFFFFFFFFFFFDDDDCCCCDAACAAACCFFFF",
"AAAAAAAAAAAAFCCCFFDDDDDCCCCDAAACAACCCEEF",
"AAAAAAAAAADDDAADFDDDDDDDDCAAADDAAFDFFFFF"}

dummy = SDL_Init(SDL_INIT_VIDEO)
if dummy = -1 then
    puts(1, "SDL_Init had a hissy fit!\n")
end if

surface = SDL_SetVideoMode(640,480,16,SDL_FULLSCREEN)

format=peek4u(surface+4)
pixels=peek4u(surface+20)

tiles=SDL_LoadBMP("Bitmaps/Tiles.bmp")

map=SDL_CreateRGBSurface(SDL_SWSURFACE,320,320,32,#FF,#FF00,#FF0000,#FF000000)

SDL_PumpEvents()
SDL_WarpMouse(10,10)

srect=allocate(8)
drect=allocate(8)

px=0
py=0
cc=0

-- use the PumpEvents and GetMouseState to see if a mouse button has been pressed
done=0    
while done=0 do
    SDL_PumpEvents()
    keystate=SDL_GetKeyState(NULL)
    if peek(keystate+SDLK_ESCAPE)>0 then
        done=1        
    end if
    if peek(keystate+SDLK_UP)>0 then
        py=py-1
        if py<0 then
            py=19    
        end if
    end if
    if peek(keystate+SDLK_DOWN)>0 then
        py=py+1
        if py>19 then
            py=0    
        end if
    end if
    if peek(keystate+SDLK_LEFT)>0 then
        px=px-1
        if px<0 then
            px=39    
        end if
    end if
    if peek(keystate+SDLK_RIGHT)>0 then
        px=px+1
        if px>39 then
            px=0    
        end if
    end if
    SDL_PumpEvents()
    dummy=SDL_GetMouseState(0,0)
    if dummy = -1 then
        puts(1, "SDL_GetMouseState had a hissy fit!\n")
    end if
    if dummy!=0 then
        done=1
    end if

    for x=0 to 9 do
        xx=px+x
        if xx>39 then
            xx=xx-40    
        end if
        if xx<0 then
            xx=xx+40 
        end if
        for y=0 to 9 do
            yy=py+y
            if yy>19 then
                yy=yy-20    
            end if
            if yy<0 then
                yy=yy+20    
            end if
            c=world[yy+1][xx+1]
            c=(c-'A')+1
            poke(srect,{0,0,0,0,32,0,32,0})
            poke(drect,{0,0,0,0,32,0,32,0})
            t=c*32
            poke(srect,remainder(t,256))      
            poke(srect+1,floor(t/256))      
            t=x*32
            poke(drect,remainder(t,256))      
            poke(drect+1,floor(t/256))      
            t=y*32
            poke(drect+2,remainder(t,256))      
            poke(drect+3,floor(t/256))      
            dummy=SDL_BlitSurface(tiles,srect,map,drect)
            if dummy = -1 then
                puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
            end if
        end for
    end for
    dummy=SDL_SetColorKey(tiles,SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
    if dummy = -1 then
        puts(1, "SDL_SetColorKey had a hissy fit!\n")
    end if
    poke(drect,{144,0,144,0,32,0,32,0})
    cc=1-cc
    if cc=0 then
        poke(srect,{0,0,0,0,32,0,32,0})
        dummy=SDL_BlitSurface(tiles,srect,map,drect)
        if dummy = -1 then
            puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
        end if
    else
        poke(srect,{224,0,0,0,32,0,32,0})
        dummy=SDL_BlitSurface(tiles,srect,map,drect)
        if dummy = -1 then
        puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
        end if
    end if
    dummy=SDL_SetColorKey(tiles,0,SDL_MapRGB(format,0,0,0))
    if dummy = -1 then
        puts(1, "SDL_SetColorKey had a hissy fit!\n")
    end if
    poke(srect,{0,0,0,0,64,1,64,1})
    poke(drect,{160,0,80,0,64,1,64,1})
    dummy=SDL_BlitSurface(map,srect,surface,drect)
    if dummy = -1 then
        puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
    end if
    SDL_UpdateRect(surface,0,0,0,0)
end while

-- We're done with them.. Free the surfaces
SDL_FreeSurface(surface)
SDL_FreeSurface(map)
SDL_FreeSurface(tiles)
free(srect)
free(drect)

-- quit SDL
SDL_Quit()


